## ataqv 1.1.1+ds

=== Makefile ===
#
# VARIABLES
#

VERSION = 1.1.1

#
# PATHS
#

SRC_DIR = src
CPP_DIR = $(shell realpath -e $(SRC_DIR)/cpp)
SCRIPTS_DIR = $(SRC_DIR)/scripts
WEB_DIR = $(SRC_DIR)/web
BUILD_DIR = build
TEST_DIR = testing

SRC_CPP := $(wildcard $(CPP_DIR)/*.cpp)
SRC_HPP := $(wildcard $(CPP_DIR)/*.hpp)
INCLUDES := $(addprefix -I,$(CPP_DIR))

SCRIPTS := $(wildcard $(SCRIPTS_DIR)/*)

# where to install -- the default location assumes environment modules
# are in use, but you can simply override prefix with a command like
# 'make install prefix=...'
MODULES_ROOT = /lab/sw/modules
prefix = $(MODULES_ROOT)/ataqv/$(VERSION)

# where to install the modulefile
MODULEFILES_ROOT = /lab/sw/modulefiles
MODULEFILE_PATH = $(MODULEFILES_ROOT)/ataqv/$(VERSION)

#
# FLAGS
#

CPPFLAGS = -pedantic -Wall -Wextra -Wwrite-strings -Wstrict-overflow -fno-strict-aliasing -fPIC $(INCLUDES)
CXXFLAGS = -std=c++11 -pthread -O3 -g $(CPPFLAGS)
CXXFLAGS_DEV = -std=c++11 -pthread -O3 -g $(CPPFLAGS)
CXXFLAGS_STATIC = -std=c++11 -O3 -Wl,--whole-archive -lpthread -Wl,--no-whole-archive -static -static-libgcc -static-libstdc++ -I$(HTSLIB_STATIC_DIR) $(CPPFLAGS)

#
# Try to locate dependencies using environment variables
#

#
# Boost
#

#
# If your Boost installation used their 'tagged' layout, the libraries
# will include metadata in their names. Specify BOOST_TAGGED=yes in
# your make command to link with tagged libraries.
#
ifdef BOOST_TAGGED
	BOOST_LIBS = -lboost_filesystem-mt -lboost_iostreams-mt -lboost_system-mt -lboost_chrono-mt
else
	BOOST_LIBS = -lboost_filesystem -lboost_iostreams -lboost_system -lboost_chrono
endif

ifdef BOOST_ROOT
	CPPFLAGS += -I$(BOOST_ROOT)/include
	LDFLAGS += -L$(BOOST_ROOT)/lib
else
	ifdef BOOST_INCLUDE
		CPPFLAGS += -I$(BOOST_INCLUDE
	endif

	ifdef BOOST_LIB
		LDFLAGS += -L$(BOOST_LIB)
	endif
endif

#
# HTSlib
#
ifdef HTSLIB_ROOT
	CPPFLAGS += -I$(HTSLIB_ROOT)/include
	LDFLAGS += -L$(HTSLIB_ROOT)/lib
else
	ifdef HTSLIB_INCLUDE
		CPPFLAGS += -I$(HTSLIB_INCLUDE)
	endif

	ifdef HTSLIB_LIB
		LDFLAGS += -L$(HTSLIB_LIB)
	endif
endif

#
# htslib can be built with cURL to support HTTPS, which is cool, but
# drags in more libraries
#
ifdef HTSLIBCURL
	HTS_LIBS = -lhts -lssl -lcurl -lcrypto
else
	HTS_LIBS = -lhts
endif

LDLIBS = $(BOOST_LIBS) $(HTS_LIBS) -lz -lncurses -lpthread
HTSLIB_STATIC_DIR = $(HOME)/sw/bio/htslib/htslib
LDLIBS_STATIC = -L$(HTSLIB_STATIC_DIR) $(LDLIBS) -lbz2 -llzma -ltinfo -lrt

#
# Architecture flags
#
UNAME_P := $(shell uname -p)
ifeq ($(UNAME_P),x86_64)
	CPPFLAGS += -D AMD64
endif
ifneq ($(filter %86,$(UNAME_P)),)
	CPPFLAGS += -D IA32
endif
ifneq ($(filter arm%,$(UNAME_P)),)
	CPPFLAGS += -D ARM
endif

UNAME_S := $(shell uname -s)

ifeq ($(UNAME_S),Linux)
	CPPFLAGS += -D LINUX
endif

#
# TARGETS
#

.PHONY: all checkdirs clean deb deb-static rpm install install-ataqv install-module install-scripts install-web test

all: checkdirs $(BUILD_DIR)/ataqv

static: checkdirs $(BUILD_DIR)/ataqv-static

dist: checkdirs $(BUILD_DIR)/ataqv
	make install DESTDIR=$(BUILD_DIR)/ataqv-$(VERSION) prefix=
	cd $(BUILD_DIR) && tar czf ataqv-$(VERSION).$(shell uname -m).$(shell uname -s).tar.gz ataqv-$(VERSION)

dist-static: checkdirs $(BUILD_DIR)/ataqv-static
	make install DESTDIR=$(BUILD_DIR)/ataqv-$(VERSION) prefix=
	install -m 0755 $(BUILD_DIR)/ataqv-static $(BUILD_DIR)/ataqv-$(VERSION)/bin/ataqv
	cd $(BUILD_DIR) && tar czf ataqv-$(VERSION).$(shell uname -m).$(shell uname -s).tar.gz ataqv-$(VERSION)

deb:
	(cd .. && tar czf ataqv_$(VERSION).orig.tar.gz --exclude .git --exclude build ataqv)
	debuild -uc -us

deb-static: deb static
	install -m 0755 $(BUILD_DIR)/ataqv-static debian/ataqv/usr/bin/ataqv
	sed -i '/Depends: /d' debian/ataqv/DEBIAN/control
	dh_builddeb

rpm: deb
	(cd .. && alien -r ataqv_$(VERSION)-1_amd64.deb)

rpm-static: deb-static
	(cd .. && alien -r ataqv_$(VERSION)-1_amd64.deb)

checkdirs: $(BUILD_DIR) $(TEST_DIR)

$(BUILD_DIR):
	@mkdir -p $@

$(TEST_DIR):
	@mkdir -p $@

$(BUILD_DIR)/ataqv: $(BUILD_DIR)/ataqv.o $(BUILD_DIR)/Features.o $(BUILD_DIR)/HTS.o $(BUILD_DIR)/IO.o $(BUILD_DIR)/Metrics.o $(BUILD_DIR)/Peaks.o $(BUILD_DIR)/Utils.o
	$(CXX) -o $@ $^ $(LDFLAGS) $(LDLIBS)

$(BUILD_DIR)/ataqv-static: $(CPP_DIR)/ataqv.cpp $(CPP_DIR)/Features.cpp $(CPP_DIR)/HTS.cpp $(CPP_DIR)/IO.cpp $(CPP_DIR)/Metrics.cpp $(CPP_DIR)/Peaks.cpp $(CPP_DIR)/Utils.cpp
	$(CXX) -o $@ $^ $(CXXFLAGS_STATIC) $(LDFLAGS) $(LDLIBS_STATIC)

$(BUILD_DIR)/%.o: $(CPP_DIR)/%.cpp $(SRC_HPP) $(CPP_DIR)/Version.hpp
	$(CXX) $(CXXFLAGS) -o $@ -c $<

$(CPP_DIR)/Version.hpp: Makefile
	@echo '//' >$@
	@echo '// Copyright 2015 Stephen Parker' >>$@
	@echo '//' >>$@
	@echo '// Licensed under Version 3 of the GPL or any later version' >>$@
	@echo '//' >>$@
	@echo >>$@
	@echo '#define VERSION "$(VERSION)"' >>$@

test: checkdirs $(CPP_DIR)/Version.hpp $(TEST_DIR)/run_ataqv_tests
	@cp testdata/* $(TEST_DIR)
	@cd $(TEST_DIR) && ./run_ataqv_tests -i
	@cd $(TEST_DIR) && lcov --no-external --quiet --capture --derive-func-data --directory $(CPP_DIR) --directory . --output-file ataqv.info && lcov --remove ataqv.info $(CPP_DIR)/catch.hpp --output-file ataqv.info && lcov --remove ataqv.info $(CPP_DIR)/json.hpp --output-file ataqv.info && genhtml ataqv.info -o ataqv

$(TEST_DIR)/run_ataqv_tests: $(TEST_DIR)/run_ataqv_tests.o $(TEST_DIR)/test_features.o $(TEST_DIR)/test_hts.o $(TEST_DIR)/test_io.o $(TEST_DIR)/test_metrics.o $(TEST_DIR)/test_peaks.o $(TEST_DIR)/test_utils.o $(TEST_DIR)/Features.o $(TEST_DIR)/HTS.o $(TEST_DIR)/IO.o $(TEST_DIR)/Metrics.o $(TEST_DIR)/Peaks.o $(TEST_DIR)/Utils.o
	$(CXX) -o $@ $^ $(LDFLAGS) --coverage $(LDLIBS)

$(TEST_DIR)/%.o: $(CPP_DIR)/%.cpp $(SRC_HPP)
	$(CXX)  $(CXXFLAGS_DEV) -fprofile-arcs -ftest-coverage -o $@ -c $<

clean:
	@rm -rf $(BUILD_DIR) $(TEST_DIR ) $(CPP_DIR)/Version.hpp
	@test -x dh_clean && dh_clean || true

install: checkdirs install-ataqv install-scripts install-web

install-ataqv: $(BUILD_DIR)/ataqv
	@echo "Installing to $(prefix)"
	strip $(BUILD_DIR)/ataqv
	install -d -m 0755 $(DESTDIR)$(prefix)/bin
	install -m 0755 build/ataqv $(DESTDIR)$(prefix)/bin

install-scripts: $(SCRIPTS)
	install -d -m 0755 $(DESTDIR)$(prefix)/bin
	for f in $^; do sed -e 's/{{VERSION}}/$(VERSION)/g' $$f > $(BUILD_DIR)/$$(basename $$f); install -m 0755 $(BUILD_DIR)/$$(basename $$f) $(DESTDIR)$(prefix)/bin; done

install-web: $(WEB_DIR)
	install -d -m 0755 $(DESTDIR)$(prefix)/share/ataqv/web
	cp -a $^/* $(DESTDIR)$(prefix)/share/ataqv/web
	find $(DESTDIR)$(prefix)/share/ataqv/web -type d -exec chmod 755 {} \;
	find $(DESTDIR)$(prefix)/share/ataqv/web -type f -exec chmod 644 {} \;

ifdef MODULEFILE_PATH

# template for environment module file
define MODULEFILE
#%Module1.0
set           version          $(VERSION)
set           app              ataqv
set           modroot          $(MODULES_ROOT)/$$app/$$version
setenv        ATAQV_MODULE     $$modroot

prepend-path  PATH             $$modroot/bin

conflict      ataqv

module-whatis "ATAC-seq QC toolkit, version $$version."
module-whatis "URL:  https://github.com/ParkerLab/ataqv"
module-whatis "Installation directory: $$modroot"
endef
export MODULEFILE

install-module: install
	mkdir -p `dirname $(DESTDIR)$(MODULEFILE_PATH)`
	echo "$$MODULEFILE" > $(DESTDIR)$(MODULEFILE_PATH)

endif

=== debian/changelog ===
ataqv (1.1.1+ds-3) unstable; urgency=medium

  * Make the build reproducible courtesy of Chris Lamb. (Closes: #959714)
  * debian/upstream/metadata: Add Repository & Repository-Browse

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 06 May 2020 15:19:39 +0200

ataqv (1.1.1+ds-2) unstable; urgency=medium

  * Team upload.
  * Remove trailing whitespace in debian/copyright (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

 -- Andreas Tille <tille@debian.org>  Fri, 03 Apr 2020 20:48:52 +0200

ataqv (1.1.1+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #951483)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Mon, 17 Feb 2020 08:31:08 +0100

=== debian/control ===
Source: ataqv
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 12),
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-system-dev,
               libboost-chrono-dev,
               libhts-dev,
               libncurses5-dev,
               libtinfo-dev,
               zlib1g-dev,
               libjs-jquery,
               libjs-jquery-datatables,
               libjs-jquery-datatables-extensions,
               fonts-font-awesome,
               node-normalize.css,
               help2man,
               python3,
               node-d3
Standards-Version: 4.5.0
Vcs-Browser: https://salsa.debian.org/med-team/ataqv
Vcs-Git: https://salsa.debian.org/med-team/ataqv.git
Homepage: https://github.com/ParkerLab/ataqv/
Rules-Requires-Root: no

Package: ataqv
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends},
         libjs-jquery,
         libjs-jquery-datatables,
         libjs-jquery-datatables-extensions,
         fonts-font-awesome,
         node-normalize.css,
         python3,
         node-d3
Suggests: picard-tools,
          samtools,
          macs,
          wget
Description: ATAC-seq QC and visualization
 A toolkit for measuring and comparing ATAC-seq results, made in the
 Parker lab at the University of Michigan. They wrote it to help
 understand how well their ATAC-seq assays had worked, and to make it
 easier to spot differences that might be caused by library prep or
 sequencing.

## ataqv 1.2.1+ds

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # VARIABLES
 #
 
-VERSION = 1.1.1
+VERSION = 1.2.1
 
 #
 # PATHS

=== debian/changelog ===
ataqv (1.2.1+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * debhelper-compat 13 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 01 Oct 2020 13:29:23 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: ataqv
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
-Uploaders: Michael R. Crusoe <michael.crusoe@gmail.com>
+Uploaders: Michael R. Crusoe <crusoe@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                libboost-filesystem-dev,
                libboost-iostreams-dev,
                libboost-system-dev,

=== debian/watch ===
version=4

opts="repacksuffix=+ds,dversionmangle=auto,repack,compression=xz" \
  https://github.com/ParkerLab/ataqv/releases .*/archive/@ANY_VERSION@@ARCHIVE_EXT@

## ataqv 1.3.0%2Bds

=== debian/changelog ===
ataqv (1.3.0+ds-2) unstable; urgency=medium

  * Team upload.
  * Fix watch file
  * Standards-Version: 4.6.1 (routine-update)
  * lintian-overrides due to lintian bug #1017966

 -- Andreas Tille <tille@debian.org>  Fri, 30 Sep 2022 12:41:15 +0200

ataqv (1.3.0+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Add missing build dependency on dh addon.

 -- Andreas Tille <tille@debian.org>  Sun, 16 Jan 2022 08:12:45 +0100

ataqv (1.2.1+ds-2) unstable; urgency=medium

  * Team upload.
  * Fix watchfile to detect new versions on github
  * Standards-Version: 4.6.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Thu, 07 Oct 2021 10:23:21 +0200

## ataqv 1.3.0+ds

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # VARIABLES
 #
 
-VERSION = 1.2.1
+VERSION = 1.3.0
 
 #
 # PATHS
@@ -143,7 +143,7 @@
 
 deb:
 	(cd .. && tar czf ataqv_$(VERSION).orig.tar.gz --exclude .git --exclude build ataqv)
-	debuild -uc -us
+	debuild -uc -us -d
 
 deb-static: deb static
 	install -m 0755 $(BUILD_DIR)/ataqv-static debian/ataqv/usr/bin/ataqv

=== debian/control ===
--- 
+++ 
@@ -19,8 +19,9 @@
                node-normalize.css,
                help2man,
                python3,
-               node-d3
-Standards-Version: 4.5.0
+               node-d3,
+               debhelper
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/ataqv
 Vcs-Git: https://salsa.debian.org/med-team/ataqv.git
 Homepage: https://github.com/ParkerLab/ataqv/

=== debian/rules ===
#!/usr/bin/make -f

DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_configure:
	cp -sf /usr/share/nodejs/d3/dist/d3.min.js src/web/js/d3.min.js
	cp -sf /usr/share/javascript/jquery-datatables-extensions/JSZip/jszip.min.js src/web/js/jszip.min.js
	cp -sf /usr/share/javascript/jquery-datatables-extensions/Buttons/css/buttons.dataTables.min.css src/web/css/datatables.buttons.min.css
	cp -sf /usr/share/javascript/jquery-datatables/css/jquery.dataTables.min.css src/web/css/datatables.min.css
	cp -sf /usr/share/fonts-font-awesome/css/font-awesome.min.css src/web/css/font-awesome.min.css
	cp -sf /usr/share/javascript/normalize.css/normalize.css src/web/css/normalize.css
	cp -sf /usr/share/fonts-font-awesome/fonts/* src/web/fonts/
	cp -s /usr/share/javascript/jquery/jquery.min.js \
		/usr/share/javascript/jquery-datatables-extensions/pdfmake/build/pdfmake.min.js \
		/usr/share/javascript/jquery-datatables/jquery.dataTables.min.js \
		/usr/share/javascript/jquery-datatables-extensions/Buttons/js/dataTables.buttons.min.js \
		/usr/share/javascript/jquery-datatables-extensions/Buttons/js/buttons.colVis.min.js \
		/usr/share/javascript/jquery-datatables-extensions/Buttons/js/buttons.html5.min.js \
		/usr/share/javascript/jquery-datatables-extensions/Buttons/js/buttons.print.min.js \
		/usr/share/javascript/jquery-datatables-extensions/Responsive/js/dataTables.responsive.min.js \
		src/web/js/
	rm -f src/web/js/datatables.min.js

override_dh_auto_build:
	dh_auto_build -- all testing/run_ataqv_tests

override_dh_auto_install:
	dh_auto_install -- prefix=/usr

override_dh_installman:
	help2man --no-info --name="QC metrics for ATAC-seq data" build/ataqv > debian/ataqv.1
	help2man --no-info --name="Turns ataqv results into a web app" src/scripts/mkarv > debian/mkarv.1
	help2man --no-info --name="serve an instance of the ataqv web results viewer" --version-string $(DEB_VERSION_UPSTREAM) src/scripts/srvarv > debian/srvarv.1
	dh_installman

=== debian/watch ===
version=4

opts="repacksuffix=+ds,dversionmangle=auto,repack,compression=xz,filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/ParkerLab/ataqv/tags .*/@ANY_VERSION@@ARCHIVE_EXT@

## ataqv 1.3.1+ds

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 # VARIABLES
 #
 
-VERSION = 1.3.0
+VERSION = 1.3.1
 
 #
 # PATHS

=== debian/changelog ===
ataqv (1.3.1+ds-3) unstable; urgency=medium

  * Team upload.
  * d/watch: version=5
  * Drop libboost-system-dev from Build-Depends
    Closes: #1127171
  * Standards-Version: 4.7.3 (routine-update)
  * Remove Priority field to comply with Debian Policy 4.7.3 (routine-
    update)
  * Update watch file format version to 4.
  * Add dversionmangle for repack versioning in debian/watch.
  * Reorder Files paragraphs in debian/copyright by directory depth.
  * debputy lint --auto-fix (routine-update)

 -- Andreas Tille <tille@debian.org>  Mon, 09 Feb 2026 22:39:26 +0100

ataqv (1.3.1+ds-2) unstable; urgency=medium

  * Team upload.
  * d/clean: Clean files copied during configure (Closes: #1044021, #1049553)

 -- Lance Lin <lq27267@gmail.com>  Thu, 14 Dec 2023 22:46:56 +0700

ataqv (1.3.1+ds-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * Build-Depends: s/libncurses5-dev/libncurses-dev/

 -- Andreas Tille <tille@debian.org>  Mon, 03 Jul 2023 14:19:28 +0200

=== debian/control ===
--- 
+++ 
@@ -2,15 +2,12 @@
 Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
 Uploaders: Michael R. Crusoe <crusoe@debian.org>
 Section: science
-Priority: optional
 Build-Depends: debhelper-compat (= 13),
                libboost-filesystem-dev,
                libboost-iostreams-dev,
-               libboost-system-dev,
                libboost-chrono-dev,
                libhts-dev,
-               libncurses5-dev,
-               libtinfo-dev,
+               libncurses-dev,
                zlib1g-dev,
                libjs-jquery,
                libjs-jquery-datatables,
@@ -21,7 +18,7 @@
                python3,
                node-d3,
                debhelper
-Standards-Version: 4.6.1
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/med-team/ataqv
 Vcs-Git: https://salsa.debian.org/med-team/ataqv.git
 Homepage: https://github.com/ParkerLab/ataqv/

=== debian/watch ===
version=4
opts=dversionmangle=s/\+(dfsg|ds|debian|repack)(\d*)$// Version: 5

Template: Github
opts=dversionmangle=s/\+(dfsg|ds|debian|repack)(\d*)$// Owner: ParkerLab
opts=dversionmangle=s/\+(dfsg|ds|debian|repack)(\d*)$// Project: ataqv
opts=dversionmangle=s/\+(dfsg|ds|debian|repack)(\d*)$// Dversion-Mangle: auto
opts=dversionmangle=s/\+(dfsg|ds|debian|repack)(\d*)$// Repack-Suffix: +ds
